

;#define bx           saferam1        ; 1 byte  - ball x coord
;#define by           bx+1         ; 1 byte  - ball y coord
#define sy        savesscreen+1        ; 1 byte  - num blocks
#define cy           sy+1      ; 2 bytes - score
#define tmpx            cy+1         ; 1 byte  - temp x coord
#define bmtally          tmpx+1
#define bmtarget          bmtally+1
#define ktally           bmtarget+1
#define over           ktally+1
#define ctally          over+1
#define cytarget         ctally+1
#define hits          cytarget+1
#define player          hits+1
#define cyt             player+1
#define cx              cyt+1
#define sx              cx+1
#define scorel         sx+1
#define scorer         scorel+1
#define bx      savesscreen+19 
#define by     savesscreen+20
#define bxa       savesscreen+21
#define bya   savesscreen+22
#define cyt2 savesscreen+24
;define up to 10 balls, savesscreen+22+ 4X10= savesscreen+62
#define gamemode savesscreen+63
#define ballnumber savesscreen+64


;---------------= header =--------------
#include	"ti83plus.inc"			;General TI-83 Plus include file
#include	"mirage.inc"			;MirageOS include file
#define kDel   127
	.org	$9d93				;Origin (set back two to account for AsmPrgm)
	.db	$BB,$6D				;Compiled AsmPrgm token
	ret					;So TIOS wont run the program
	.db	1				;Identifier as MirageOS program
 .db %11111010,%10111110
 .db %11011001,%01011110
 .db %00100110,%10000000
 .db %00001111,%00100100
 .db %00011110,%00110100
 .db %00101110,%00101100
 .db %00000111,%00100100
 .db %01101111,%00000000
 .db %11111101,%01000100
 .db %11101111,%01101100
 .db %01110110,%01010100
 .db %01101010,%01000100
 .db %00000100,%00000000
 .db %11001011,%10111110
 .db %11011110,%11111110
        .db     "Pong z80",0              
					;Program code starts here
start:
progstart:
  ld a,0
  ld (bx),a
  ld (over),a

  bcall(_grbufclr)
  ld hl,blackgr
  ld de,sy
  ld bc,768
  call disprlel
  ld a,0
  ld l,a  
  ld b,64               
  ld c,12       
  ld ix,sy
  call ilsprite  

; ld hl,blackgr
; ld de,PlotsScreen
; call DispRLE 
; call ifastcopy
  ld hl,0
  ld a,-8
  call part5
  ld hl,1
  ld a,0
  call part5
  
  ld a,1
  ld (over),a  

part2:
  ld a,(bx)
  ld b,a
  ld a,27
  ld l,a  
  ld a,24
  add a,b
  ld b,10               
  ld c,1       
  ld ix,asmby2
  call ilsprite        ;draws logo
  call ifastcopy       ;copy graph buffer to screen   
  ld hl,2
  ld a,(bx)
  inc a
  ld (bx),a
  cp 8
  jp z,part5
  inc hl
  cp 16
  jp z,part5
  inc hl
  cp 24
  jp z,part5
  inc hl 
  cp 32
  jp z,part5
  inc hl
  cp 40
  jp z,part5
  cp 45
  jp z,part3
;  ld b,1
 ; call delayb
  jp part2
  
part5:
  ex de,hl
  ld (tmpx),de
  ld (sx),a
  ld a,11
  ld (by),a
  ld b,a
part6:
  ld a,b
  ld (by),a
  ld a,37
  sub b
  ld l,a  
  ld a,(sx)
  ld b,a
  ld a,32
  add a,b
  ld b,1               
  ld c,1       
  ld ix,asmby1
  add ix,de  
  call isprite  
  ld de,(tmpx)
  ld hl,7
  add hl,de
  ex de,hl
  ld (tmpx),de
  ld a,(by)
  ld b,a
  djnz part6
  ld a,(over)
  cp 1
  jp z,part2
  ret

part3:

part33:    
  bcall(_getcsc)       ;pause
  cp skEnter
  jr nz,part33

;display title screen and options

  ld hl,(scoresave)
  ld a,h
  cp 0 
  jr z,firsttime 
  ld hl,(scoresave)
  ld a,h
  inc a
  ld (cyt),a
  ld a,l
  ld (cyt2),a
  jr initvars

firsttime:
 ld a,3
 ld (cyt),a
 sub 1
 ld (cyt2),a  



initvars:
  bcall(_grbufclr) 
 ld a,0
 ld (player),a
 ld a,(cyt)
 dec a
 ld (cyt),a
 ld hl,boardrle
 ld de,PlotsScreen
 call DispRLE
 call dpongstr 
 call ifastcopy
part44:
  bcall(_getcsc)       ;pause
  cp skEnter
  jr nz,part44
   set textInverse, (iy+textflags)
menu:  
      ld hl,txt1
        ld      de,24*256+4             ; write "2nd - Start"
        ld      (pencol),de             ;
        bcall(_vputs)                   ;
        ld      de,31*256+4             ; write "ALPHA - Speed:"
        ld      (pencol),de             ;
        bcall(_vputs)                   ;
        ld      de,38*256+4             ; write "CLEAR - Exit:"
        ld      (pencol),de             ;
        bcall(_vputs)                   ;
         ld      de,45*256+4             ; write "2nd - Start"
        ld      (pencol),de             ;
        bcall(_vputs)                   ;
         ld      de,52*256+4             ; write "2nd - Start"
        ld      (pencol),de             ;
        bcall(_vputs)                   ;
updatm:

       call getplayertxt 
       ld      de,31*256+50            ; write "ALPHA - Speed:"
        ld      (pencol),de             ;
        bcall(_vputs)                   ;
        ld      de,38*256+58           ; write speed
        ld      (pencol),de             ;
        ld      a,(cyt)               ;
        bcall(_setxxop1)                ;
        bcall(_dispop1a)                ;
        ld      de,45*256+54           ; write speed
        ld      (pencol),de             ;
        ld      a,(cyt2)               ;
        bcall(_setxxop1)                ;
        bcall(_dispop1a)                ;
menul:  bcall(_getcsc)                    ;
        cp      skClear                     ; [CLEAR]
        jr z,resetflag                       ; quit
        cp skMode
        jr z,cplayer
        cp skAlpha
        jr z,cyt2incnow
        cp      skdel                     ; [ALPHA]
        jr      nz,nchngs               ;
        ld a,(cyt)                ; change num players
        inc a
        ld (cyt),a
        cp 4
        jr nz,updatm                  ;
        ld a,1
        ld (cyt),a
        jr updatm

cyt2incnow:
  ld a,(cyt2)                ; change num players
        inc a
        ld (cyt2),a
        cp 4
        jr nz,updatm                  ;
        ld a,1
        ld (cyt2),a
        jr updatm
cplayer:
  ld a,(player)
  inc a
  ld (player),a
  cp 3
  jr nz,updatm
  ld a,0
  ld (player),a
  jr updatm
resetflag:
  res textInverse, (iy+textflags)
  ld a,(cyt)
  ld h,a
  ld a,(cyt2)
  ld l,a
  ld (scoresave),hl
  ret  
                
nchngs: cp      sk2nd                      ; [2nd]
        jr      nz,menul                ;
   res textInverse, (iy+textflags)
 call dpongstr
 ld a,5
 ld (by),a
 ld a,44
 ld (bx),a
 ld b,14
 call putbline
 call ifastcopy
 ld a,27
 ld (sy),a
 ld (cy),a
 ld a,88
 ld (cx),a
 ld a,0
 ld (sx),a
 ld (bmtally),a
 ld (ktally),a
 ld (ctally),a
 ld (cytarget),a
 ld (scorel),a
 ld (scorer),a
 ld a,(cyt)
 inc a
 ld (cyt),a
 call doscore
 call rpbnd
 ld a,(player)
 cp 0
 jr z,main
 ld a,88
 ld (sx),a
 ld a,0
 ld (cx),a

main:
    call checkover
    ld   a,0ffh          ;Reset keyport
    out     (1),a
    ld a, 0fdh          ;Enable Key Group with the mode in it.
    out (1), a
    in a, (1)    
    cp 191
    jp z,initvars   

    ld a,(ktally)          ; only moves every other loop
    inc a
    cp 2 
    jr z,pcantmove
    ld (ktally),a

    ld   a,0ffh          ;Reset keyport
    out     (1),a
    ld a, 0FEh          ;Enable Key Group with the Arrows in it.
    out (1), a
    in a, (1)
    cp %11111110            ;Check for Down.
    jp z, Down
    cp %11110111            ;Check for Up.
    jp z, Up
    call draw
    jr main

up:
 ld a,(sy)
 sub 5
 jp m,cantmove
 add a,4
 ld (sy),a
 jr cantmove

down:
 ld a,(sy)
 sub 50
 jp p,cantmove
 add a,51
 ld (sy),a
 jr cantmove

pcantmove:
 ld a,0
 ld (ktally),a
cantmove:
 call draw  
 jp main
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

draw:
 call movecomp        ; ai stuff
 call dleftp        ; draw left paddle
 call drightp       ;draw right paddle
 call bmove         ; move ball
 call dbpos2        ; check any x coord hits
 call dball2        ;draw ball
 call ifastcopy
 call dball2        ;erase ball
 call dbpos         ;check y coord hits
 call dleftp        
 call drightp

 ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

dbpos:
 ld a,(bmtally)
 cp 0
 ret nz
 jp dbpos1
 
dbpos1:
 ld a,(by)
 cp 4
 jr z,ldbyap
 cp 57
 jr z,ldbyam
 ret
 
ldbyap:
 ld a,1
 ld (bya),a
 ret

ldbyam:
 ld a,-1
 ld (bya),a
 ret

bmove:
 ld a,(bmtarget)
 inc a
 ld b,a
 ld a,(bmtally)
 inc a
 ld (bmtally),a
 cp b
 ret nz
 ld a,0
 ld (bmtally),a
 ld a,(bxa)
 ld b,a
 ld a,(bx)
 add a,b
 ld (bx),a
 ld a,(bya)
 ld b,a
 ld a,(by)
 add a,b
 ld (by),a
 ret


dbpos2:
 ld a,(bx)
 cp 3
 jr z,getpixleft
 cp 86
 jr z,getpixright
 ret

getpixleft:
 ld a,(by)
 ld e,a
 ld a,4
 call pixeltest
  jr      z,ldbxap
 ld a,(by)
 inc a
 ld e,a
 ld a,4
 call pixeltest
  jr      z,ldbxap
 ld a,1
 ld (over),a
 ret

getpixright:
 ld a,(by)
 ld e,a
 ld a,91
 call pixeltest
  jr      z,ldbxam
 ld a,(by)
 inc a
 ld e,a
 ld a,91
 call pixeltest
 jr      z,ldbxam
 ld a,2
 ld (over),a
 ret

ldbxap:
 ld a,1
 ld (bxa),a
 ld a,(bmtally)
 cp 0
 ret nz
 ld a,(hits)
 inc a
 cp 12
 ret z
 ld (hits),a
 cp 2
 jr z,incbmt
 cp 5
 jr z,incbmt
 cp 8
 jr z,incbmt
 cp 11
 jr z,incbmt
 ret

ldbxam:
 ld a,-1
 ld (bxa),a
 ret

incbmt:
 ld a,0
 ld (bmtally),a
 ld a,(bmtarget)
 dec a
 ret m
 ld (bmtarget),a
 ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
checkover:
 ld a,(over)
 cp 0
 ret z
 cp 1
 jr z,incsp2
 call doscore
 ld a,(scorel)
 inc a
 ld (scorel),a
 jr doscores
 
incsp2:
 call doscore
 ld a,(scorer)
 inc a
 ld (scorer),a
 

doscores:
 cp 10
 jp z,dowin
 call doscore
 jp rpbnd

doscore:
 ld a,(scorel)
 ld de,0
 call gethl
 ld a,8
 ld l,a
 ld a,39
 ld b,6              
 ld c,1       
 ld ix,numbers
 add ix,de
 call ilsprite
 ld a,(scorer)
 ld de,0
 call gethl
 ld a,8
 ld l,a
 ld a,52
 ld b,6              
 ld c,1       
 ld ix,numbers
 add ix,de
 call ilsprite
 ret

gethl:
 cp 0
 ret z
 inc de
 inc de
 inc de
 inc de
 inc de
 inc de
 dec a
 jr gethl

dowin:
 pop hl
    set textInverse, (iy+textflags)
 call getwhowon
        ld      de,29*256+33             ; write "2nd - Start"
        ld      (pencol),de             ;
        bcall(_vputs)   
   res textInverse, (iy+textflags)
  halt
  halt
  halt
  halt
  halt
part55:
  bcall(_getcsc)       ;pause
  cp skEnter
  jr nz,part55
  jp initvars

getwhowon:
 ld a,(player)
 cp 0
 jr nz,getwhowon2
 ld a,(over)
 ld hl,txt9
 cp 1
 ret z
 ld hl,txt8
 ret 

getwhowon2:
 ld a,(over)
 ld hl,txt11
 cp 1
 ret z
 ld hl,txt10
 ret
 
;;;;;;;;;;;;;



dleftp: 
  ld a,(sy)
  ld l,a
  ld a,(sx)
  ld b,10               
  ld c,1       
  ld ix,paddle
  jp ilsprite

drightp: 
  ld a,(cy)
  ld l,a
  ld a,(cx)
  ld b,10               
  ld c,1       
  ld ix,paddle
  jp ilsprite

rpbnd:
 ld b,13
 call irandom
 inc a
 sla a
 sla a
 inc a
 ld (by),a
 ld a,44
 ld (bx),a
 ld b,2
 call irandom
 sla a
 dec a
 ld (bxa),a
 ld b,2
 call irandom
 sla a
 dec a
 ld (bya),a
 ld a,0
 ld (over),a
 ld (hits),a
 ld a,(cyt2)
 add a,1
 ld (bmtarget),a
 ret


putbline:
 push bc
 call dball
 ld a,(by)
 add a,4
 ld (by),a
 pop bc
 djnz putbline
 ret

dball:
  ld a,(by)
  ld l,a  
  ld a,(bx)
  ld b,2               
  ld c,1        
  ld ix,ball
  jp ilsprite 

dball2:
  ld a,(by)
  ld l,a  
  ld a,(bx)
  ld b,3               
  ld c,1        
  ld ix,ball2
  jp ilsprite   

dpongstr:
  ld a,15
  ld l,a  
  ld a,36
  ld b,8               
  ld c,3        
  ld ix,pongstr
  jp ilsprite

getkeys2:
  ld a,(ktally)
  cp 0
  ret z
  ld   a,0ffh          ;Reset keyport
    out     (1),a
    ld a, 0dfh          ;Enable Key Group with the mode in it.
    out (1), a
    in a, (1)    
    cp 127
    jp z,cyinc
  ld   a,0ffh          ;Reset keyport
    out     (1),a
    ld a, 0bfh          ;Enable Key Group with the mode in it.
    out (1), a
    in a, (1)    
    cp 223
    jp z,cydec      
   ret

getlink:
  call getbytetios
  ret nz
  cp 1
  jp z,cydec
  cp 2
  jp z,cyinc
  ret


movecomp:
 ld a,(player)
 cp 0
 jr z,getcompm
 cp 1
 jp z,getkeys2
 cp 2
 jr z,getlink
getcompm:
 ld a,(bxa)
 ret m
 ld a,(bx)
 cp 44
 jr nz,ldcymove
;predict @ 86
 ld a,(by)
 ld (cytarget),a
 ld a,(bya)
 ld c,a
 ld b,42
predictloop:
 ld a,(cytarget)
 add a,c
 ld (cytarget),a
 djnz predictloop
 jp m,changesign
thereturn:
 sub 6
 jp m,ldcy4
 add a,4
 ld (cytarget),a
 sub 57
 jp p,ldcyminus
 add a,9
 ret m
 ld a,50
 ld (cytarget),a
 ret

changesign:
 ld b,a
 ld a,0
 sub b
 add a,4
 jr thereturn

ldcymove:
 ld a,(cyt)
 ld b,a
 ld a,(ctally)
 inc a
 ld (ctally),a
 cp b 
 ret nz
 ld a,0
 ld (ctally),a
 ld a,(bx)
 sub 44
 ret m

 ld a,(cytarget)
 ld b,a
 ld a,(cy)
 sub b
 cp 0
 ret z
 jp p,cydec
 ld a,(cyt)
 ld b,a
 call irandom
 cp 2
 ret z
 cp 3
 ret z
 ld a,(cy)
 inc a
 ld (cy),a 
 ret

ldcyminus:
 ld b,a
 ld a,50
 sub b
 ld (cytarget),a
 ret 

ldcy4:
 ld a,4
 ld (cytarget),a
 ret

cydec:
 ld a,(cy)
 dec a
 cp 3
 ret z
 ld (cy),a
 ret

cyinc:
 ld a,(cy)
 inc a
 cp 51
 ret z
 ld (cy),a
 ret

getplayertxt:
 ld a,(player)
 ld hl,txt5
 cp 0
 ret z
 ld hl,txt6
 cp 1
 ret z
 ld hl,txt7
 ret

scoresave:
  .dw 000000000000000000000,0

ball2:
 .db %00111000
 .db %00111000
 .db %00111000
ball:
 .db %00011000
 .db %00011000 


paddle:
 .db %00011000
 .db %00011000
 .db %00011000
 .db %00011000
 .db %00011000
 .db %00011000
 .db %00011000
 .db %00011000
 .db %00011000
 .db %00011000

numbers:
 .db %01110000
 .db %01010000
 .db %01010000
 .db %01010000
 .db %01010000
 .db %01110000

 .db %00100000
 .db %00100000
 .db %00100000
 .db %00100000
 .db %00100000
 .db %00100000

 .db %01110000
 .db %00010000
 .db %01110000
 .db %01000000
 .db %01000000
 .db %01110000

 .db %01110000
 .db %00010000
 .db %01110000
 .db %00010000
 .db %00010000
 .db %01110000

 .db %01010000
 .db %01010000
 .db %01110000
 .db %00010000
 .db %00010000
 .db %00010000

 .db %01110000
 .db %01000000
 .db %01110000
 .db %00010000
 .db %00010000
 .db %01110000

 .db %01110000
 .db %01000000
 .db %01110000
 .db %01010000
 .db %01010000
 .db %01110000

 .db %01110000
 .db %00010000
 .db %00010000
 .db %00010000
 .db %00010000
 .db %00010000


 .db %01110000
 .db %01010000
 .db %01110000
 .db %01010000
 .db %01010000
 .db %01110000


 .db %01110000
 .db %01010000
 .db %01110000
 .db %00010000
 .db %00010000
 .db %00010000

boardrle:
 .db $91,%11111111,24,%11000000,$91,%00000000,10,%00000011,%11000000,$91,%00000000,10,%00000011
 .db $91,%11111111,0,$91,%11111111,0,$91,%11111111,160,%11000000,$91,%00000000,10,%00000011
 .db %11000000,$91,%00000000,10,%00000011,$91,%11111111,24


nmm: .db "Nick Monu",0

txt1:
 .db "2ND - Start",0

txt2:
 .db "MODE - VS:",0

txt3:
 .db "DEL - Difficulty:",0

txt34:
 .db "ALPHA - Speed:",0

txt4:
 .db "CLEAR - Quit",0

txt6:
 .db " Human A ",0

txt5:
 .db " Comp        ",0

txt7:
 .db " Human B ",0

txt8:
 .db "You win",0

txt9:
 .db "You lose",0

txt10:
 .db " P1 Wins",0

txt11:
 .db " P2 Wins",0

asmby1:
 .db %00000001,%10000001,%10000000,%00000000,%00000000,%00000000,%00000000
 .db %01111110,%01111110,%01111111,%10000000,%00000000,%00001100,%00000000
 .db %00111100,%00000001,%10110000,%00000000,%00000000,%00000000,%00000000
 .db %00110011,%01100010,%01001111,%00010011,%11111111,%11111111,%00000000
 .db %01101101,%10111101,%10000001,%00101100,%11100110,%10000000,%00000000
 .db %01101001,%10110001,%11100001,%00100101,%00101010,%10100000,%00100000
 .db %01101001,%10111101,%10110001,%00100101,%00101010,%10100000,%00100000
 .db %01111101,%10011101,%10011001,%00100101,%11101010,%11100000,%11000000
 .db %00010000,%00000000,%00000000,%00000000,%00000000,%00000000,%10000000
 .db %01000000,%11111111,%11111111,%11111111,%11111111,%11110011,%00000000
 .db %01000000,%00000000,%00000000,%00000000,%00000000,%00000010,%00000000

asmby2:
 .db %00100000
 .db %00000000
 .db %00001000
 .db %00000000
 .db %00000011
 .db %00000011
 .db %00001100
 .db %00001100
 .db %00110000
 .db %00110000


blackgr:
 .db $91,%11111111,0,$91,%11111111,0,$91,%11111111,0


pongstr:
 .db %00111101,%11101111,%01111000
 .db %00100101,%00101001,%01001000
 .db %00100101,%00101001,%01001000
 .db %10101101,%11101001,%01101010
 .db %00100000,%00000000,%00001000
 .db %00100000,%00000000,%00001000
 .db %00100000,%00000000,%00001000
 .db %00100000,%00000000,%01111000
